﻿/*
# Apprendre à programmer en ActionScript 3
# A. Tasso
# Chapitre 10 : Le traitement de données multimédia
# Projet Le mini site 
# Fichier : ChargeurInfo.as
*/

package {
	import flash.display.*;
	import flash.events.*;
	import flash.net.*;
	import flash.text.*;
	public class ChargeurInfo extends Sprite {
		// Charger les informations de la page Infos
		public function ChargeurInfo(rub: String ) {
			var url:String="../"+rub+"/"+rub+".xml";
			var chargeurXML:URLLoader = new URLLoader();
			chargeurXML.dataFormat = URLLoaderDataFormat.TEXT;
			chargeurXML.addEventListener(Event.COMPLETE, gestionInfo);
			chargeurXML.load(new URLRequest(url));

		}
		// Calculer la longueur d'une branche XML
		private function calculerLongueur(liste:XMLList):uint {
			var compteur:uint = 0;
			for each (var elt:XML in liste) {
				compteur++;
			}
			return compteur;
		}
		// Traiter les données stockées dans le fichier infos.xml
		private function gestionInfo(e:Event):void {
			try {
				var nbRubriques:uint = 0;
				var leTitre,leType, leContenu:String;
				var nombre:uint;
				var elt:XML;
				var titreAffiche, lienAffiche:TitreTexte;
				//  Crée un objet XML et un objet XMLList
				var donneesLues:XML = new XML(e.target.data);
				var puce:Forme;
				var couleur:uint=0x660066;
				var listeXML:XMLList = new XMLList();
				listeXML = donneesLues.elements();
				nbRubriques = calculerLongueur(listeXML);
                // Pour chaque rubrique de la page Infos
				for (var i:int=0; i < nbRubriques; i++) {
					// Stocker le titre
					leTitre = donneesLues.info[i].@titre;
					// Stocker le type
					leType = donneesLues.info[i].@type;
					// Stocker le contenu
					leContenu = donneesLues.info[i].@contenu;
					// Si le type est textuel
					if (leType == "texte") {
						// Créer un titre
						titreAffiche= new TitreTexte(500, 0X000000, 20, "Arial",leTitre);
						// l'afficher horizontalement en supprimant l'effet rollover (false)
						titreAffiche.dessinerHorizontal(70, MiniSite.finalYPage+100+ i* 50, false);
						addChild(titreAffiche);
						// Initialisation de la couleur de la puce
						couleur = 0xCC0033;
						// Afficher le contenu à la suite en supprimant l'effet rollover (false)
						lienAffiche= new TitreTexte(350,  0x000000, 20, "Arial",leContenu);
						lienAffiche.dessinerHorizontal(MiniSite.largeurPage/3+50, MiniSite.finalYPage+100+ i* 50, false);
						addChild(lienAffiche);
					}
					// Si le type est une adresse mail
					if (leType == "mail") {
						// Créer un titre
						titreAffiche= new TitreTexte(500, 0X000000, 20, "Arial",leTitre);
						// l'afficher horizontalement en supprimant l'effet rollover (false)
						titreAffiche.dessinerHorizontal(70, MiniSite.finalYPage+100+ i* 50, false);
						addChild(titreAffiche);
						// Initialisation de la couleur de la puce
						couleur = 0x009999;
						// Afficher le contenu à la suite en ajoutant l'effet rollover (true)
						lienAffiche= new TitreTexte(350,  0x009999, 20, "Arial",leContenu);
						lienAffiche.dessinerHorizontal(MiniSite.largeurPage/3+50, MiniSite.finalYPage+100+ i* 50, true);
						addChild(lienAffiche);
						lienAffiche.addEventListener(MouseEvent.MOUSE_UP, clicSurMail);
					}
					// Si le type est un lien cliquable
					if (leType == "lien") {
						// Créer un titre
						titreAffiche= new TitreTexte(100, 0X000000, 20, "Arial",leTitre);
						// l'afficher horizontalement en supprimant l'effet rollover (false)
						titreAffiche.dessinerHorizontal(70, MiniSite.finalYPage+100+ i* 50, false);
						addChild(titreAffiche);
						// Initialisation de la couleur de la puce
						couleur = 0x000066;
						// Afficher le contenu à la suite en ajoutant l'effet rollover (true)
						lienAffiche= new TitreTexte(100, 0X000066, 20, "Arial",leContenu);
						lienAffiche.dessinerHorizontal(MiniSite.largeurPage/3+50, MiniSite.finalYPage+100+ i* 50, true);
						addChild(lienAffiche);
						lienAffiche.addEventListener(MouseEvent.MOUSE_UP, clicSurLien);
					}
					// Créer atafficher une puce avec la couleur associée
					puce = new Forme(i, 10, 10, couleur,"" , 0, false);
					puce.x = 50;
					puce.y = MiniSite.finalYPage+105+ i* 51;
					addChild(puce);
				}
			} catch (e:TypeError) {
				trace("Imposible de charger le XML");
				trace(e.message);
			}
		}
		private function clicSurLien(e:MouseEvent) {
			var cible:TitreTexte = e.currentTarget  as TitreTexte;
			var request:URLRequest = new URLRequest(cible.contenu);
			try {
				// Ouvrir le navigateur par défaut à l'adresse indiquée en paramètre
				navigateToURL(request);
			} catch (e:Error) {
				// traitement des erreurs
			}
		}
		private function clicSurMail(e:MouseEvent) {
			var cible:TitreTexte = e.currentTarget  as TitreTexte;
			try {
				// Ouvrir la messagerie par défaut avec un contenu et un sujet
				var quelMail:String = "mailto:"+cible.contenu+"?subject=Une question en AS3&body=Bonjour,";
				navigateToURL( new URLRequest(quelMail),"_blank");
			} catch (e:Error) {
					// traitement des erreurs
			}
		}
	}// Fin de la classe ChargeurInfos

}