﻿/*
# Apprendre à programmer en ActionScript 3
# A. Tasso
# Chapitre 10 : Le traitement de données multimédia
# Projet Le mini site 
# Fichier : TitreTexte.as
*/

package {
	import flash.text.*;
	import flash.display.*;
	import flash.events.*;
	import flash.filters.*;
	import flash.system.*;

	public class TitreTexte extends Sprite {
		// a. Définition des propriétés d'une TitreTexte
		private var couleur, largeur, taille:uint;
		public var contenu:String;
		private var police:String;
		private var format:TextFormat;

		public function TitreTexte(nlar:Number, ncou:uint, ntai:uint, npol:String, ncont:String) {
			// Pour faire en sorte d'afficher le texte avec une fonte non standard
			Font.registerFont( AristaFont );
			Font.registerFont( ApplicationDomain.currentDomain.getDefinition ( "AristaFont" ) as Class );
			largeur = nlar;
			couleur = ncou;
			taille = ntai;
			police = npol;
			contenu = ncont;
			format = new TextFormat(police, taille);
			format.color = couleur;
		}
	
	    // Afficher un texte à la vertical, avec un fond transparent, 
		// pour garder le curseur en forme de main, lorsque la souris passe dessus
		public function dessinerVertical(nx:Number, ny:Number):void {
			format.align = TextFormatAlign.CENTER;
			format.leading  = -8;
			var tmp =  new TextField();
			tmp.defaultTextFormat = format;
			tmp.selectable = false;
			tmp.height = tmp.textHeight -100;
			tmp.autoSize = TextFieldAutoSize.CENTER;
			tmp.embedFonts  = true;
			var leTexte:Array =new Array();
			for (var i:Number=0; i < contenu.length; i++) {
				leTexte[i] = contenu.charAt(i);
			}
			var textVertical :String = leTexte.join("\n");
			tmp.text = textVertical;
			tmp.x = nx;
			tmp.y = ny;
			tmp.filters = [new DropShadowFilter(0, 45,0X000000,1,5,5,1.64,3)];
			var boite:Sprite = new Sprite();
			var fond:Sprite = new Sprite();
			fond.graphics.beginFill(0xFFFFFF);
			fond.graphics.drawRect(0, 0,  tmp.textWidth+10,tmp.textHeight);
			fond.graphics.endFill();
			fond.x = nx ;
			fond.y = ny;
			fond.alpha=0;
			addChild(fond);
			boite.addChild(tmp);
			boite.addChild(fond);
			addChild(boite);
		}
		
		// Afficher un texte à l'horizontal, avec un fond transparent, 
		public function dessinerHorizontal(nx:Number, ny:Number, over:Boolean):void {
			var tmp =  new TextField();
			tmp.selectable = false;
			tmp.autoSize = TextFieldAutoSize.LEFT;
			tmp.embedFonts  = true;
			tmp.defaultTextFormat = format;
			tmp.text = contenu ;
			tmp.x = nx;
			tmp.y = ny;
			addChild(tmp);
			var boite:Sprite = new Sprite();
			var fond:Sprite = new Sprite();
			fond.graphics.beginFill(0xFFFFFF);
			fond.graphics.drawRect(0, 0,  tmp.textWidth+10,tmp.textHeight);
			fond.graphics.endFill();
			fond.x = nx ;
			fond.y = ny;
			fond.alpha=0;
			addChild(fond);
			boite.addChild(tmp);
			boite.addChild(fond);
			addChild(boite);
			// Si over vaut true, le texte devient sensible au rollover, un curseur en forme de  main apparaît
			if (over) {
				boite.buttonMode = true;
				addEventListener(MouseEvent.MOUSE_OVER, surOver);
				addEventListener(MouseEvent.MOUSE_OUT, surOut);
			}
		}
		function surOver(e:MouseEvent):void {
			var cible:Sprite = e.currentTarget  as Sprite;
			cible.alpha = 0.4;
			cible.buttonMode = true;
		}
		// L'opacité de l'objet revient à l'état initial
		function surOut(e:MouseEvent):void {
			var cible:Sprite = e.currentTarget  as Sprite;
			cible.alpha = 1;
		}
		public function sAfficher():void {
			trace("--------------------- Titre -----------------------------");

			trace("taille  = " +  taille);
			trace("police  = " +  police);
			trace("couleur = " +  couleur);
			trace("contenu =" + contenu);
			trace("--------------------------------------------------------");
		}
	}// Fin de la classe TitreTexte
}